// VS2005: Disable deprecated function warnings
#pragma warning( disable : 4996 )

// Windows stuff
#include "StdAfx.h"

// Other required includes
#include <d3d9.h>
#include <d3dx9core.h>
#include <stdio.h>
#include <dbodata.h>
#include <iostream>
using namespace std;

// GlobStruct include and definition
#include "GlobStruct.h"
extern GlobStruct* g_pGlob;

// Export definition
#define EXPORT __declspec(dllexport)

// Typedefs for accessing Pro functions
typedef bool				(*BISI)		( int, char*, int );				// Bool = (Int, String, Int)
typedef sObject*			(*OI)		( int );							// Object = (Int)
typedef	bool				(*BODDD)	( sMesh*, DWORD, DWORD, DWORD );	// Bool = (Mesh, Dword, Dword, Dword)
typedef bool				(*BO)		( sMesh* );							// Bool = (Mesh)
typedef void				(*VIF)		( int, float );						// Void = (Int, Float)
typedef void				(*VII)		( int, int );						// Void = (Int, Int)
typedef LPDIRECT3DDEVICE9	(*OV)		( void );							// D3D_Device = (Void)
typedef DWORD				(*DD)		( DWORD );							// Dword = (Dword)
typedef int					(*II)		( int );							// Int = (Int)

extern	BISI				CreateNewObject;
extern	OI					GetObjectData;
extern	BODDD				SetupFVFData;
extern	BO					CalculateMeshBounds;
extern	VIF					SetNewObjectFinalProperties;
extern	VII					SetTexture;
extern	VII					SetDetailTexture;
extern	DD					GetInternalData;
extern	VIF					SetFOV;
extern	II					GetExistEx;
// Vertex option definitions
#define D3DFVF_2D_VERTEX		(D3DFVF_XYZRHW | D3DFVF_DIFFUSE)
#define D3DFVF_DBPMESH			(D3DFVF_XYZ | D3DFVF_NORMAL | D3DFVF_TEX1)
#define D3DFVF_MY_VERTEX		(D3DFVF_XYZ | D3DFVF_DIFFUSE)
#define D3DFVF_BATCH_VERTEX		(D3DFVF_XYZ | D3DFVF_DIFFUSE | D3DFVF_PSIZE)

// Vertex structures
struct TransformedVertex			// D3D_FVF_2D_VERTEX
{
    float x, y, z, w;				// Position of vertex in 3D space
    DWORD color;					// Colour of vertex
};

struct sVertex						// D3DFVF_DBPMESH
{
    float x, y, z;					// Vertex positions
    float nx, ny, nz;				// Vertex normals
    float tu, tv;					// Vertex mapping coords
};

struct Vertex						// D3DFVF_MY_VERTEX
{
    float x, y, z;					// Vertex positions
    DWORD color;					// Vertex colour
};
// Font details
struct FontInfo
{
    LPSTR			sFontname;		// Font name (3D Text)
    ID3DXFont*		pFont;			// Font ptr (2D Text)
	bool			bBold;			// Is bold (3D Text)
	bool			bItalic;		// Is italic (3D Text)
	int				iHeight;		// Font size (3D Text)
};

//Camera Datails
struct CameraDets
{
	float			FOV;
	float			CameraNear;
	float			CameraFar;
	D3DVIEWPORT9	pViewPort;
};

// Various other stuff
extern	IDirect3DDevice9*		g_pD3DDevice;
extern	LPDIRECT3DVERTEXBUFFER9	g_pVB_Box;
extern	ID3DXSprite*			g_pTextSprite;
extern	DWORD					g_Forecolour;
extern	TransformedVertex		g_pTS_Box[4];
extern	ID3DXMesh*				g_pMesh3D;
extern	D3DVIEWPORT9			g_pViewPort;
extern	FontInfo				fiFont[20];			// Font details

// Export mesh to object functions
extern void MakeObjectFromDXMesh (int iID, ID3DXMesh *ppMesh);

// Export table
extern "C"
{
	// General functions
	EXPORT	void	InitD3D					( void );
	EXPORT	void	DrawColor				( int, int, int, int );
	EXPORT	DWORD	D3DRGBA					( int, int, int, int );

	// 2D functions
	EXPORT	void	GradientBox				( int, int, int, int, DWORD, DWORD, DWORD, DWORD );
	EXPORT	void	Box						( int, int, int, int );
	EXPORT	void	ColourBox				( int, int, int, int, DWORD );
	EXPORT	void	PolygonUnfilled			( int, int, float, float, int, DWORD );
	EXPORT	void	PolygonFilled			( int, int, float, float, int, DWORD, int );
	EXPORT	void	Circle					( int, int, float, int );
	EXPORT	void	ColourCircle			( int, int, float, int, DWORD );
	EXPORT	void	Elipse					( int, int, float, float, int );
	EXPORT	void	ColourElipse			( int, int, float, float, int, DWORD );
	EXPORT	void	D3DPolygon				( int, int, float, int, int );
	EXPORT	void	ColourPolygon			( int, int, float, int, int, DWORD );
	EXPORT	void	Dot						( int, int );
	EXPORT	void	ColourDot				( int, int, DWORD );
	EXPORT	void	Line					( int, int, int, int);
	EXPORT	void	ColourLine				( int, int, int, int, DWORD );
	EXPORT	void	GradientLine			( int, int, int, int, DWORD, DWORD );
	EXPORT	void	SetBatchSizeDot2D		( int );
	EXPORT	void	AddBatchDot2D			( int, int );
	EXPORT	void	ColourAddBatchDot2D		( int, int, DWORD );
	EXPORT	void	BatchDrawDot2D			( int );
	EXPORT	void	SetBatchSizeLine2D		( int );
	EXPORT	void	AddBatchLine2D			( int, int, int, int );
	EXPORT	void	ColourAddBatchLine2D	( int, int, int, int, DWORD );
	EXPORT	void	GradientAddBatchLine2D	( int, int, int, int, DWORD, DWORD );
	EXPORT	void	BatchDrawLine2D			( int );

	// 3D functions
	EXPORT	void	Dot3D					( float, float, float, float );
	EXPORT	void	Dot3DCZ					( float, float, float, float, DWORD, int );
	EXPORT	void	Dot3DCamera				( int, float, float, float, float, DWORD, int );
	EXPORT	void	Line3D					( float, float, float, float, float, float );
	EXPORT	void	Line3DCZ				( float, float, float, float, float, float, DWORD, int );
	EXPORT	void	Line3DGCZ				( float, float, float, float, float, float, DWORD, DWORD, int );
	EXPORT	void	Line3DCamera			( int, float, float, float, float, float, float, DWORD, DWORD, int );
	EXPORT	void	Circle3D				( float, float, float, float, float, float, float );
	EXPORT	void	Circle3DCZ				( float, float, float, float, float, float, float, DWORD, int );
	EXPORT	void	Circle3DCamera			( int, float, float, float, float, float, float, float, DWORD, int );
	EXPORT	void	Ellipse3D				( float, float, float, float, float, float, float, float );
	EXPORT	void	Ellipse3DCZ				( float, float, float, float, float, float, float, float, DWORD, int );
	EXPORT	void	Ellipse3DCamera			( int, float, float, float, float, float, float, float, float, DWORD, int );
	EXPORT	void	Polygon3D				( int, float, float, float, float, float, float, float, float, int, DWORD, int );
	EXPORT	void	SetBatchSizeDot3D		( int );
	EXPORT	void	SetBatchDot3DSize		( float );
	EXPORT	void	AddBatchDot3D			( float, float, float );
	EXPORT	void	ColourAddBatchDot3D		( float, float, float, DWORD );
	EXPORT	void	BatchDrawDot3D			( int, int, int);
	EXPORT	void	SetBatchSizeLine3D		( int );
	EXPORT	void	AddBatchLine3D			( float, float, float, float, float, float );
	EXPORT	void	AddBatchLine3DC			( float, float, float, float, float, float, DWORD );
	EXPORT	void	AddBatchLine3DGC		( float, float, float, float, float, float, DWORD, DWORD );
	EXPORT	void	BatchDrawLine3D			( int, int, int);
	EXPORT	void	MakeObjectTeapot		( int );
	EXPORT	void	MakeObjectPolygon		( int, int );
	EXPORT	void	MakeObjectTorus			( int, float, float, int, int );
	EXPORT	void	MakeObjectPyramid		( int, float, float, float );

	// Text functions
	EXPORT	void	BoxText					( int, int, int, int, int, int, int, LPSTR );
	EXPORT	void	BoxTextColour			( int, int, int, int, int, int, int, LPSTR, DWORD );
	EXPORT	void	DrawAAText				( int, int, int, int, LPSTR );
	EXPORT	void	DrawAATextColour		( int, int, int, int, LPSTR, DWORD );
	EXPORT	void	StartText				( void );
	EXPORT	void	EndText					( void );
	EXPORT	void	SetFont					( int, LPSTR, int, int, int, int );
	EXPORT	int		GetTextWidth			( int, LPSTR );
	EXPORT	int		GetTextHeight			( int, LPSTR );
	EXPORT	void	Text3D					( int, int, LPSTR, float, int, int );

	EXPORT	void	GetCameraPick			( int, int, int, float );
	EXPORT	void	GetCameraNormal			( int );
	EXPORT	DWORD	GetCameraX				( void );
	EXPORT	DWORD	GetCameraY				( void );
	EXPORT	DWORD	GetCameraZ				( void );
	EXPORT	void	SetOrthoProjection		( int , float );
	EXPORT	void	RestoreCamera			( int );
	EXPORT  int		CursorInCamera			( int , int );

	EXPORT	int		GetDesktopWidth			( void );
	EXPORT	int		GetDesktopHeight		( void );
	EXPORT	int		GetDesktopDepth			( void );
	EXPORT	int		RoundValue				( float );
	EXPORT	DWORD	Round					( float, int);
}
